/* * * * * * * * * * * * * * * * * dfall.c * * * * * * * * * * * * * * * * *

A program to report the amount of total disk space, used disk space,
free disk space, percentage of free disk space on all disk drives, and
the amount of total DOS memory and the amount of DOS free memory.
*/

#include <stdlib.h>
#include <dos.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <conio.h>
#include <direct.h>
#include <bios.h>

/* Global Variables */
char  cpyright[]="Copyright (c) 1989, Albert J. Wallace, Push-N-Pop Software";
int   disk_err=0;
FILE *fp;

/* Function Prototypes */
char *ultoafmt(unsigned long);
char *findvol(unsigned);
int round(unsigned long,unsigned long);
void main(int,char *[]);
void syntax_error_exit(void);
void cls(void);
void far hardhandler(void);

void main(argc,argv)
int argc;
char *argv[];
{
               int   result,
                     first_drive,
                     last_drive=26,  /* Change to suit you needs */
                     PRINTER = 0;
          unsigned   drv_number=0,
                     equipment=0,
                     memory;
     unsigned long   free_dsk_space=0,
                     tot_dsk_space=0,
                     used_dsk_space=0,
                     gr_free_dsk_space=0,
                     gr_tot_dsk_space=0,
                     gr_used_dsk_space=0,
                     int_tot=0,
                     pgm_start,
                     tot_memory;
  struct diskfree_t  drive;
               char *output_device="lpt1"; /* Default printer */

   _harderr(hardhandler); /* Install our hard error handler. */

   memory=_bios_memsize(); /* Get total memory and compute free memory */
   tot_memory=((unsigned long) memory)<<10;  /* Multiply by 1024 */
   pgm_start=((unsigned long)_psp)<<4;       /* Multiply by 16   */

   equipment=_bios_equiplist();       /* Get equipment list from BIOS */
   if(equipment&1)                    /* Determine number of floppies */
      equipment=(((equipment&0x00c0)>>6)+1);
   else
      equipment=2;                    /* If none, then "C:" drive first */
  
   if(getenv("DFALLL")!=NULL)   /* Check environmental variables */
      last_drive=((int)toupper(*getenv("DFALLL")))-64;

   if(getenv("DFALLP")!=NULL)
      output_device=getenv("DFALLP");

   switch (argc){                     /* Determine if printer selected */
      case 2:
         if((argv[1][0]=='/')&&toupper(argv[1][1])=='P'){
            PRINTER = 1;
            if(strlen(argv[1])>2)
               output_device=&argv[1][2];
         }
         break;
      case 3:
         if(argv[2][0]=='/'&&toupper(argv[2][1])=='P'){
            PRINTER = 1;
            if(strlen(argv[2])>2)
               output_device=&argv[2][2];
         }
         break;
      case 4:
         if(argv[3][0]=='/'&&toupper(argv[3][1])=='P'){
            PRINTER = 1;
            if(strlen(argv[3])>2)
               output_device=&argv[3][2];
         }
         break;
   }
   switch (argc){     /* Check for parameters */
      case 1:
         first_drive=equipment+1;
         break;
      case 2:
         if(!PRINTER){
            if(!isalpha(argv[1][0]))
               syntax_error_exit();
            first_drive=toupper(argv[1][0])-64;
         }
         else{
            first_drive=equipment+1;
         }
         break;
      case 3:
      if (!PRINTER){
         if(!isalpha(argv[1][0])||!isalpha(argv[2][0])||
            toupper(argv[1][0])>toupper(argv[2][0]))
               syntax_error_exit();
         first_drive=toupper(argv[1][0])-64;
         last_drive =toupper(argv[2][0])-64;
        }
        else{
            if(!isalpha(argv[1][0]))
               syntax_error_exit();
            else{
               first_drive=toupper(argv[1][0])-64;
            }
         }
         break;
      case 4:
         if(!isalpha(argv[1][0])||!isalpha(argv[2][0])||
            toupper(argv[1][0])>toupper(argv[2][0]))
               syntax_error_exit();
         else{
            first_drive=toupper(argv[1][0])-64;
            last_drive =toupper(argv[2][0])-64;
         }
         break;
      default:
         syntax_error_exit();
   }

   if(PRINTER)             /* Open output device */
      fp=fopen(output_device,"w");
   else{
      fp=fopen("con","w");
      cls();             
   }
   fprintf(fp,
      "                                      DFALL\n        %s\n\n",cpyright);
   fprintf(fp,
      "   Drive   Vol ID           Total          Used           Free"
         "    %c Free\n",'%');
   fflush(fp);
   for(drv_number=first_drive;drv_number<=last_drive;++drv_number){
      if(equipment==1&&drv_number==2)   /*If only one drive, ignore drive B:*/
         continue;
      result=_dos_getdiskfree (drv_number,&drive);
      if(!disk_err){
         if(!result){
            int_tot = (unsigned long) drive.sectors_per_cluster *
               drive.bytes_per_sector;
            tot_dsk_space  = (unsigned long) drive.total_clusters * int_tot;
            free_dsk_space = (unsigned long) drive.avail_clusters * int_tot;
            gr_free_dsk_space+=free_dsk_space;
            gr_tot_dsk_space+=tot_dsk_space;
            used_dsk_space = tot_dsk_space - free_dsk_space;
            fprintf(fp,"     %c:  ",drv_number + 64);
            fprintf(fp,"%-12s",findvol(drv_number));
            fprintf(fp,"    %s",ultoafmt(tot_dsk_space));
            fprintf(fp,"  %s ",ultoafmt(used_dsk_space));
            fprintf(fp,"  %s",ultoafmt(free_dsk_space));
            fprintf(fp,"  %3d%c\n",round(free_dsk_space,tot_dsk_space),'%');
            tot_dsk_space=0;
            free_dsk_space=0;
            fflush(fp);
         }
      }
      else{        /* Reset error flag and print message */
         disk_err=0;
         fprintf(fp,"     %c:    * not ready *\n",drv_number + 64);
         fflush(fp);
      }
   }   
   gr_used_dsk_space = gr_tot_dsk_space - gr_free_dsk_space;
   if(gr_tot_dsk_space!=0){
      if(PRINTER)
         fprintf(fp,
"    ____________________________________________________________________\n\n");
      else
         fprintf(fp,
"    \n");
      fprintf(fp,"\tTotals");
      fprintf(fp,"\t         %s",ultoafmt(gr_tot_dsk_space));
      fprintf(fp,"  %s ",ultoafmt(gr_used_dsk_space));
      fprintf(fp,"  %s",ultoafmt(gr_free_dsk_space));
      fprintf(fp,"  %3d%c\n",round(gr_free_dsk_space,gr_tot_dsk_space),'%');
      fprintf(fp,
         "\n\t  Total memory is%-8s bytes\n",ultoafmt(tot_memory));
      fprintf(fp,
         "\t   Free memory is%-8s bytes\n",ultoafmt(tot_memory-pgm_start));
      if(PRINTER){
         if(strchr(output_device,'.')==NULL) /*If contains '.', no form feed*/
            fprintf(fp,"\f");  /* Send formfeed to printer */
      }
      fclose(fp);
      if(PRINTER)
         printf("DFALL is finished.\n");
      exit(0);   /* Normal program termination, return code 0 */
      }
   else{
      printf("\n    No space on selected drive(s)!\n");
      fclose(fp);
      exit(1);
      }
}

/* Converts an unsigned long to a string with commas */
char *ultoafmt(x)
unsigned long x;
{
   int i,j=10;
   char strval[9];
   static char strout[12];
   ultoa(x,strval,10);
   strcpy(strout,"            ");
   for(i=strlen(strval)-1;i>=0;i--){
      strout[j--]=strval[i];
      if(!((strlen(strval)-i)%3)&&(i>0))
         strout[j--]=',';
   }
   return (strout);
}

/* Error handler */
void far hardhandler(void)
{
   disk_err = 1;
   _hardretn(0);
}

/* Syntax Error Exit */
void syntax_error_exit()
{
   printf("Invalid parameters\n");
   printf("Syntax: dfall [d1: [d2:]] [/P[device|file name]\n");
   printf("d1-first drive  d2-last drive /P-Output to Printer\n");
   fclose(fp);
   exit(1);
}

/* Round Percent Free */
int round(free_space,total_space)
unsigned long free_space,total_space;
{
   ldiv_t ret_val;
   total_space/=100;
   ret_val=ldiv(free_space,total_space);
   if(((ret_val.rem*10)/total_space)>=5&&ret_val.quot!=99)
      ++ret_val.quot;
   return (int) ret_val.quot;
}

/* Returns a pointer to Volume ID of the disk "drive" */
char *findvol(drive)
unsigned drive;
{
   struct find_t volid;
   static char buffer[13];
   int i,j;
   char *path = " :\*.*";

   path[0]=(char) (drive+64);
   if(_dos_findfirst(path,_A_VOLID,&volid))
      strcpy(buffer,"none");
   else{
      for(i=0,j=0;i<=strlen(volid.name);++i){
         if(volid.name[i]=='.'){
            if(i<=8)
               continue;
            else
               buffer[j++]=volid.name[i];
         }
         else
               buffer[j++]=volid.name[i];
      }
   }
   return (buffer);
}

